﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using HLWebOKBAdminPlugin.OKBAdministrationService;
using HLWebOKBAdminPlugin.Helpers;

namespace HLWebOKBAdminPlugin.Models {
    public class AlgorithmModel {
        
        public String SelectedSubMenu { get; set; }
        public IList<Algorithm> Algorithms { get { return AlgorithmsGetAll(); } }

        public Algorithm Algorithm { get; set; }

        public AlgorithmModel() {
            Algorithm = new Algorithm();
        }//AlgorithmModel

        //***************************************Algorithms*************************************************
        private IList<Platform> PlatformsGetAll() {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            IList<Platform> platformList = new List<Platform>();

            if (adminClient != null) {
                Platform[] platforms = adminClient.GetPlatforms();
                foreach (Platform pl in platforms) {
                    platformList.Add(pl);
                }
            }//if (adminClient != null)

            return platformList;
        }//ProblemClassGetAll

        private IList<ProblemClass> ProblemClassGetAll() {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            IList<ProblemClass> problemClassList = new List<ProblemClass>();

            if (adminClient != null) {
                ProblemClass[] problemClasses = adminClient.GetProblemClasses();
                foreach (ProblemClass pc in problemClasses) {
                    problemClassList.Add(pc);
                }
            }//if (adminClient != null)

            return problemClassList;
        }//ProblemClassGetAll

        //get all algorithms
        private IList<Algorithm> AlgorithmsGetAll() {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            IList<Algorithm> algorithmList = new List<Algorithm>();

            if (adminClient != null) {
                Algorithm[] algorithm = adminClient.GetAlgorithms();
                foreach (Algorithm al in algorithm) {
                    algorithmList.Add(al);

                }
            }//if (adminClient != null)

            return algorithmList;
        }//AlgorithmsGetAll

        private long AddAlgorithm(Algorithm algorithm) {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            if (adminClient != null) {
                return adminClient.AddAlgorithm(algorithm);
            }

            return 0;
        }//AddAlgorithm

        public void DeleteAlgorithm(long id) {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            if (adminClient != null) {
                adminClient.DeleteAlgorithm(id);
            }
        }//DeleteAlgorithm

        public long SaveAlgorithm(Algorithm algorithm) {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            if (adminClient != null) {
                if (algorithm.Id == 0) {
                    return AddAlgorithm(algorithm);
                }
                else {
                    Algorithm al = adminClient.GetAlgorithm(algorithm.Id);

                    if (al != null) {
                        adminClient.UpdateAlgorithm(algorithm);
                        return algorithm.Id;
                    }
                }
            }

            return 0;
        }//SaveAlgorithm
        
    }
}